'use strict';

const AWS = require("aws-sdk");
const _graphite = require( 'graphite' );
const _client = _graphite.createClient( 'plaintext://serverstats.blurrt.co.uk:2003/' );

const scalingProcess = require( './scaling-manager.js' );

const sqs = new AWS.SQS({
  //sqsuser
  accessKeyId:'AKIAJEPTNRHRDNIY2KDA',
  secretAccessKey: 'password',
    region: 'eu-west-2'
});

const aws_queue_urls =
{
  dev: {
    gnip: 'https://sqs.eu-west-2.amazonaws.com/697738154271/GnipParsingQueueTest',
    parsed: 'https://sqs.eu-west-2.amazonaws.com/697738154271/ParsedQueueTest'
  },
};

var previousValues = [];
var previousValuesLength = 5;

function examineQueueSize(){
    return new Promise(function(resolve, reject){
    var params = {
          QueueUrl: aws_queue_urls.dev.gnip,
          AttributeNames:['All']
        };
      sqs.getQueueAttributes( params, function(err, data) {
      if (err){
        console.log(err, err.stack); // an error occurred
        reject( err );
        return; 
      }// an error occurred
      else{
        console.log(data);
        resolve(data);
      }
      });
    });
}

function checkQueueSizeRules(data){
  if(data.Attributes.ApproximateNumberOfMessages > 4000){
    console.log("calling to scale with up 2");
    scalingProcess._scaleProcess('up', 2);
  }
  else if(data.Attributes.ApproximateNumberOfMessages > 2000){
    console.log("calling to scale with up");
    scalingProcess._scaleProcess('up');
  }
  else if(data.Attributes.ApproximateNumberOfMessages < 500){
    console.log("calling to scale with down");
    scalingProcess._scaleProcess('down');
  }
  else{
    var scaleUpCount = 0;
    //for every value in the previous values array
    for(var i = 1; i < previousValuesLength-1; i++){
      //if it's larger than the previous one
      if(previousValues[i]>previousValues[i-1]){
        //increment the counter
        scaleUpCount += 1;
      }
    }
    //if they are all larger than the previous one scale up
    if(scaleUpCount==previousValuesLength-1){
      console.log("calling to scale with up");
      scalingProcess._scaleProcess('up');
    }
    else{
      console.log("we aren't doing anything");
    }
  }
  
  addDataValueToPreviousArray(data.Attributes.ApproximateNumberOfMessages);
  sendGraphiteGroupSizeRequest();
  sendGraphiteRequest('blurrt.sqs.unparsed_messages.dev', data.Attributes.ApproximateNumberOfMessages);
  return;
}

function addDataValueToPreviousArray(numberOfMessages){
  if(previousValues.length>=previousValuesLength){
    //5 is newest 0 is oldest
    var newArray = []
    for(var i = 1; i < previousValuesLength; i++){
      newArray[i-1] = previousValues[i];
    }
    newArray[previousValuesLength-1] = numberOfMessages;
    previousValues = newArray;
    console.log(previousValues);
  }
  else{
    previousValues.push(numberOfMessages);
    console.log(previousValues);
  }
}

function sendGraphiteRequest(metric,value){
  var metrics = {};
  metrics[metric] = value;
  console.log(metrics);
  
  _client.write( metrics, function( err )
  {
    if( err )
      return console.error( 'Error sending stats to graphite:', err );

    console.log( 'Stats sent to Graphite:', metrics );
  });
}

function sendGraphiteGroupSizeRequest(){
  //console.log("inside group size request");
  scalingProcess.describeAutoScalingGroups({
      AutoScalingGroupNames: [
          "DockerDevelopment-NodeAsg-10ARXIFYRZIED"
      ]
  }).then(function(data){
    //size of node group plus 1 manager node, shouldn't be hardcoded
    sendGraphiteRequest('blurrt.docker.total_node_count.dev',data.AutoScalingGroups[0].Instances.length + 1)
  });
}

function checkAndUpdateOperation(){
  examineQueueSize()
        .then(checkQueueSizeRules);
}

function start(){
  var timer = setInterval(function(){
    checkAndUpdateOperation();
  }, 30000);
}
start();
