'use strict';

const AWS = require("aws-sdk");
const Client = require('ssh2').Client;
const fs = require('fs');

//the user which has access to lambda and autoscaling permissions
//lambda not needed any more
const autoscaling = new AWS.AutoScaling({
  //lambdauser
  accessKeyId:'AKIAIR6UXIYL3VEG5GOA',
  secretAccessKey: 'password',
    region: 'eu-west-2'
});

const ecr = new AWS.ECR({
  //dockeruser
  accessKeyId:'AKIAI5W32RTG55UOR2RA',
  secretAccessKey: 'password',
    region: 'eu-west-2'
});

const managerNodes = {
  dev: '52.56.158.203',
  prod: ''
  
};

var GroupNames = {
    AutoScalingGroupNames: [
        "DockerDevelopment-NodeAsg-10ARXIFYRZIED"
    ]
};

var mode = "";
var magnitude = 1;

function describeAutoScalingGroups(groupNames){
  return new Promise(function( resolve, reject )
  {
    autoscaling.describeAutoScalingGroups(groupNames, function( err, groups )
    {
      if( err ){
        console.log(err, err.stack);
        reject( err );
        return;   
      }
      
      resolve(groups);
    });
  });
}

function updateDesiredCapacity(input) {
    
    var params = {
        AutoScalingGroupName: "DockerDevelopment-NodeAsg-10ARXIFYRZIED", 
        HonorCooldown: true
    };
  
  if(mode=='up'){
    params.DesiredCapacity = input.AutoScalingGroups[0].DesiredCapacity + magnitude;
  }
  else{
    params.DesiredCapacity = input.AutoScalingGroups[0].DesiredCapacity - magnitude;
  }

  return new Promise(function(resolve, reject){
    autoscaling.setDesiredCapacity(params,function(err, data) {
      if (err){
        if(err.code == 'ScalingActivityInProgress'){
          console.log("Already scaling");
        }
        else if(err.code == 'ValidationError' && err.message == 'New SetDesiredCapacity value -1 is negative.'){
          //do nothing if it's below desired capacity
        }
        else{
          console.log(err, err.stack); // an error occurred
        }
        
        return; 
      }
      console.log('successfully updated');
      resolve(params);
    });
  });

}

function waitForScalingToComplete(params){
  return new Promise(function(resolve, reject){
    //if scaling down don't bother waiting scale down in advance and let the nodes be rebalanced by docker
    if(mode=='up'){
      var conn = new Client();
      conn.on('ready', function() {
        var timer = setInterval(function(params){
          //view current node status
          conn.exec('docker node ls', function(err, stream) {
            if (err) throw err;
            stream.on('close', function(code, signal) {
              //ending the connection here was causing issues, moved into on data
              //conn.end();
              
            }).on('data', function(data) {
              console.log('STDOUT: ' + data);
              data = data.toString().split("\n");
              var dataCount = 0
              //check number of ready nodes
              for(var i = 0; i < data.length ;i++){
                if(data[i].includes(' Ready ')){
                  dataCount += 1;
                }
              }
              console.log(dataCount);
              if(data.length - 2 == params.managerNodes+params.workerNodes){
                console.log("Swarm has scaled");
                conn.end();
                clearInterval(timer);
                resolve(params);
              }
              
            }).stderr.on('data', function(data) {
              console.log('STDERR: ' + data);
              reject(params);
            });
          });
          
        }, 20000, params);
      }).connect({
              host: managerNodes.dev,
              port: 22,
              username: 'docker',
              privateKey: fs.readFileSync('/home/greg/Parsers2/Node/keys/id_rsa')
            });
    }
    else{
      resolve(params);
    }
  });
}


function getAuthorizationToken(params){
  //can't pass params as reference have to define new variable here
  var input = params;
  return new Promise(function(resolve, reject){
    ecr.getAuthorizationToken({}, function(err, data){
      if (err){
        console.log(err, err.stack); // an error occurred
        reject( err );
        return; 
      }
      else{
        
        var authToken = Buffer.from(data.authorizationData[0].authorizationToken, 'base64').toString('ascii').substring(4);
        var connectString ='docker login -u AWS -p '+ authToken +' -e none https://697738154271.dkr.ecr.eu-west-2.amazonaws.com';
        var params = {
          authString: connectString,
          containersPerNode: 2,
          workerNodes: input.DesiredCapacity,
          managerNodes: 1
        };
        
        resolve(params);
      }
    });
  });
}

function scaleSwarmService(params)
{
  return new Promise(function(resolve, reject){
    var swarmSize = params.containersPerNode*(params.managerNodes+params.workerNodes);

    var conn = new Client();
    conn.on('ready', function() {
      conn.exec(params.authString, function(err, stream) {
          if (err) throw err;
          stream.on('close', function(code, signal) {
              console.log('Stream :: close :: code: ' + code + ', signal: ' + signal);
          conn.exec('docker service scale parsingprocess='+swarmSize, function(err, stream) {
            if (err) throw err;
            stream.on('close', function(code, signal) {
              
              conn.end();
              
            }).on('data', function(data) {
              console.log('STDOUT: ' + data);
              conn.end();
              resolve(data);
              
            }).stderr.on('data', function(data) {
              console.log('STDERR: ' + data);
              conn.end();
              reject(data);
              
            });
          });
          
          }).on('data', function(data) {
              console.log('STDOUT: ' + data);
          
          }).stderr.on('data', function(data) {
              console.log('STDERR: ' + data);
          
          });
      });
    }).connect({
      host: managerNodes.dev,
      port: 22,
      username: 'docker',
      //change this to the location of your rsa key
      privateKey: fs.readFileSync('/home/greg/Parsers2/Node/keys/id_rsa')
    });
  });
}

function _scaleProcess(modeInput, magnitudeInput){
  //by default scale up if no parameters given
  if(modeInput==null){
    mode = 'up'
  }
  //throw error if bad parameter passed
  else if(modeInput!='up'&&modeInput!='down'){
    throw new Error('Unknown parameter');
  }
  else{
    mode = modeInput
  }
  
  if(magnitudeInput==null){
    magnitude = 1;
  }
  //throw error if bad parameter passed
  else if(isNaN(magnitudeInput)){
    throw new Error('magnitude value is not a number');
  }
  else{
    magnitude = magnitudeInput
  }
  
  console.log('Scaling '+mode);
  describeAutoScalingGroups(GroupNames)
              .then(updateDesiredCapacity)
              .then(getAuthorizationToken)
              .then(waitForScalingToComplete)
              .then(scaleSwarmService);
              
} 

module.exports = {
  _scaleProcess: _scaleProcess,
  describeAutoScalingGroups: describeAutoScalingGroups
}
